package com.diagbot.model.ai.process;

import com.alibaba.fastjson.JSONObject;
import com.diagbot.model.ai.model.EntityEnum;
import com.diagbot.model.ai.model.Lemma;
import com.diagbot.model.entity.BodyPart;
import com.diagbot.model.entity.Pacs;

import java.util.ArrayList;
import java.util.List;

/**
 * @author kwz
 * @date 2020/8/19
 * @time 14:03
 */
public class EntityProcessPacsNew extends EntityProcess {
    public List<Pacs> extractEntity(JSONObject aiOut) {
        //辅检情况
        List<Pacs> pacses = new ArrayList<>();
        List<Lemma> pacsLemmas = createEntityTree(aiOut, EntityEnum.AUXILIARY_DESCRIPT.toString());
        for (Lemma lemma : pacsLemmas) {
            Pacs pacs = new Pacs();
            pacs.setName(lemma.getText());
            pacs.setStandName(lemma.getText());
            if (lemma.isHaveChildren()) {
                for (Lemma relationLemma : lemma.getRelationLemmas()) {
                    if (relationLemma.getProperty().equals(EntityEnum.BODY.toString())) {
                        pacs.setBodyPart(addBodyPart(relationLemma));
                    }
                }
            }
            pacses.add(pacs);
        }
        return pacses;
    }
    /**
     * 添加身体部位
     *
     * @param relationLemma
     * @return
     */
    private BodyPart addBodyPart(Lemma relationLemma) {
        BodyPart bodyPart = new BodyPart();
        bodyPart.setName(relationLemma.getText());
        bodyPart.setStandName(relationLemma.getText());
        return bodyPart;
    }
}
